#include "vdce.h"
#include "dvm_msg.h"
#include <stdio.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>
#include <rpc/rpc.h>


extern XDR xdrp;

struct	task	*_dvminfo;
int		_total_data;
int		_myvdcetaskid;
char		*_myvdcetaskname;
FILE		*jfp;

int		_myuserid;
int 		_myapplid;
VDCE_MSG_HEADER _cvm_header;
int		_cvmsockfd;

int             _mypid;    /* added to support user abort request 1/16/98 */

ACT_format	*_actinfo;

#define	_VDCETASKERR	(0)
#define _VDCETASKINFO	(1)
#define _VDCETASKDORUN	(2)

void sig_handler()
{
	if (jfp != NULL) {
		fprintf(jfp, "catch SIGPIPE task = %d\n", 
		_myvdcetaskid);
		fflush(jfp);
	}
	else
		fprintf(stderr, "catch SIGPIPE task = %d\n", 
		_myvdcetaskid);
}

main(argc,argv)
int	argc;
char	*argv[];
{
        extern  int  optind,optopt;
        extern  int  opterr;
	int	_vdce_run_flag;
	int	_vdce_c;

	int	targc;
	
	char	*tasknam,*tptr;
	char	*targv[MAXPATHLEN];
	char	jfpoutname[MAXPATHLEN*2];
	char	*javafilename;
	int 	i;

    
        _mypid = getpid(); /* get my process ID */

	signal(SIGPIPE, sig_handler);

	/*
	 * Check master of task 
        */

   if ( (strcmp(argv[7],"master")==0) && argc == 10)  {
	/*
         * Check options of dvm
         * 'dvm -i' : only provide task inforamtion 
	 * 'dvm -r' : run the task
        */

#ifdef MAINDEBUG
	{
	   /* master task */
	   char *tnam;
           FILE *sfp;

	    tnam = (char *) malloc(MAXPATHLEN);
#ifdef DEMOLOG
            tnam = tempnam("/merlin2/users/demo/vdce/ver1/log",argv[0]);
#else
            tnam = tempnam("/tmp",argv[0]);
#endif
	    if ( (sfp = fopen(tnam,"w")) != NULL) {
	   fprintf(sfp,"%s is running my user, appli,task id = %d\n",
		argv[0],atoi(argv[4]),atoi(argv[5]), atoi(argv[6]));
		fclose(sfp);
	    }
	}
#endif

	javafilename = jfpoutname;
	tasknam = (char *) calloc(MAXPATHLEN,sizeof(char));
	_myvdcetaskname = (char *) calloc(MAXPATHLEN,sizeof(char));
	tptr = (char *) calloc(MAXPATHLEN,sizeof(char));
	tptr = (char *)strrchr(argv[0],'/');

	if (tptr==NULL) {
		sprintf(tasknam,"%s",argv[0]);
		sprintf(_myvdcetaskname,"%s",argv[0]);
	}
	else {
		*(tptr)++;
		sprintf(tasknam,"%s",tptr);
		sprintf(_myvdcetaskname,"%s",tptr);
	}

	opterr =0;
	while ( (_vdce_c=getopt(argc,argv,":ir")) !=-1) {
	    switch (_vdce_c) {
	           case 'i': 
			    _vdce_run_flag = _VDCETASKINFO;
			    break;
		   case 'r':
			    _vdce_run_flag = _VDCETASKDORUN;
			    break;
		   default:
			    _vdce_run_flag = _VDCETASKERR;
			    break;
	     }
	}

	if (optind==1)  /* There is no options */
		_vdce_run_flag = _VDCETASKERR;
		
 
	switch (_vdce_run_flag) {
	  case _VDCETASKERR : { /* error mode */

#ifdef DEMOLOG
		sprintf(javafilename,
                "/merlin2/users/demo/vdce/ver1/log/%s.err",tasknam);
#else
		sprintf(javafilename,
                "/tmp/%s.err",tasknam);
#endif

#ifdef JAVA
		jfp= fopen(javafilename,"w");
		if (jfp==NULL) jfp=stdout;
#else
		jfp = stdout;
#endif
#ifdef DEBUG
		fprintf(jfp,"filename = %s\n",javafilename);
		fprintf(jfp,"Please enter options\n");
                fprintf(jfp,
                "usage: %s [-i] [-r] #of channel socketport taskid\n",argv[0]);
#endif
		exit(1);
		}
	  case _VDCETASKINFO : { /* taskinformation mode */	
#ifdef DEBUG
#ifdef DEMOLOG
		sprintf(javafilename,
                "/merlin2/users/demo/vdce/ver1/log/%s.inf",tasknam);
#else
		sprintf(javafilename,
                "/tmp/%s.inf",tasknam);
#endif
#ifdef JAVA
		jfp= fopen(javafilename,"w");
		if (jfp==NULL) jfp=stdout;
#else
		jfp = stdout;
#endif
		fprintf(jfp,"filename = %s\n",javafilename);
#endif

		vdce_get_taskinfo();
		exit(0);
	       }
	  case _VDCETASKDORUN : { /* task will be executed */
#ifdef DEMOLOG
		sprintf(javafilename,
                "/merlin2/users/demo/vdce/ver1/log/%s%d.out",
#else
		sprintf(javafilename,
                "/tmp/%s%d.out",
#endif
		tasknam,atoi(argv[6]));/*with taskid*/
#ifdef JAVA
		jfp= fopen(javafilename,"w");
		if (jfp==NULL) jfp=stdout;
#else
		jfp = stdout;
#endif
		/*
		 * call vdce DVM initialization
		 */
#ifdef DEBUG
		 fprintf(jfp,"filename = %s\n",javafilename);
	         fprintf(jfp,"vdce_main: call vdce_init().....1\n");
		 fflush(jfp);
#endif
		if (vdce_init(argc,argv,&targc,targv)==0) {
		   fprintf(jfp,
		   "VDCE_INIT: I am sorry, I can't initialize VDCE environment.\n");
		    fflush(jfp);
		    vdce_end(STDINOUT); 
		 /*vdce_error(101) */
		   exit(1);
		}
#ifdef DEBUG
	         fprintf(jfp,"vdce_main: call a task vdce_run() \n");
		 fflush(jfp);
		/*
		 * call a task 
		 */
		  for(i=1;i<targc;i++){
		  printf("argv[%d]=%s\n",i,targv[i]);
		  fprintf(jfp, "argv[%d]=%s\n",i,targv[i]);
		  }
		  fprintf(jfp,"\n");
		  fflush(jfp);
#endif
		targv[0] = (char *) calloc(MAXPATHLEN,sizeof(char));
		sprintf(targv[0],"%s",tasknam);
		vdce_run(targc,targv);
#ifdef DEBUG
		fprintf(jfp, "vdce_run done\n");
		fflush(jfp);
#endif
		vdce_end(0);
		break;	
	  }
	  default : { /* error mode */
#ifdef DEBUG
		fprintf(jfp,"Please enter options\n");
                fprintf(jfp,
                "usage: %s [-i] [-r] #of channel socketport taskid\n",tasknam);
#endif
		exit(1);
	 }
       } /* end of switch */
     } /* for master */
     else {
#ifdef MAINDEBUG
	   /* slave task */
	   char *tnam;
           FILE *sfp;

	    tnam = (char *) malloc(MAXPATHLEN);
#ifdef DEMOLOG
            tnam = tempnam("/merlin2/users/demo/vdce/ver1/log",argv[0]);
#else
            tnam = tempnam("/tmp",argv[0]);
#endif
	    if ( (sfp = fopen(tnam,"w")) != NULL) {
	  	fprintf(sfp,"Slave is running \n");
          	{
                  int i;
                  for(i=0;i<argc;i++)
                  fprintf(sfp,"SLAVE:argv[%d]=%s\n",i,argv[i]);
		  fflush(sfp);
		}
	     }
#endif
	  vdce_run(argc,argv);
#ifdef MAINDEBUG
	fprintf(sfp,"SLAVE:vdce_run done");
   	   fclose(sfp);
#endif
	  vdce_end(0);
	  exit(1);
    } /* for slave */
}

